GraphReader< GR > Class Template Reference

- Main Page
- Modules
- Classes
- Namespaces
- Files
- Related Pages

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
List of all members | Public Member Functions | Related Functions
GraphReader< GR > Class Template Reference
LEMON Graph Format

## Detailed Description

### template<typename GR>
class lemon::GraphReader< GR >

This utility reads an LGF file.

It can be used almost the same way as `DigraphReader`. The only difference is that this class can handle edges and edge maps as well as arcs and arc maps.

The columns in the `@edges` (or `@arcs`) section are the edge maps. However, if there are two maps with the same name prefixed with `'+'` and `'-'`, then these can be read into an arc map. Similarly, an attribute can be read into an arc, if it's value is an edge label prefixed with `'+'` or `'-'`.

`#include <lemon/lgf_reader.h>`

## Public Member Functions
| GraphReader (GR &graph, std::istream &is=std::cin)
| Constructor. More...
| GraphReader (GR &graph, const std::string &fn)
| Constructor. More...
| GraphReader (GR &graph, const char *fn)
| Constructor. More...
| ~GraphReader ()
| Destructor.
Reading Rules
template<typename Map >
GraphReader & | nodeMap (const std::string &caption, Map &map)
| Node map reading rule. More...
template<typename Map , typename Converter >
GraphReader & | nodeMap (const std::string &caption, Map &map, const Converter &converter=Converter())
| Node map reading rule. More...
template<typename Map >
GraphReader & | edgeMap (const std::string &caption, Map &map)
| Edge map reading rule. More...
template<typename Map , typename Converter >
GraphReader & | edgeMap (const std::string &caption, Map &map, const Converter &converter=Converter())
| Edge map reading rule. More...
template<typename Map >
GraphReader & | arcMap (const std::string &caption, Map &map)
| Arc map reading rule. More...
template<typename Map , typename Converter >
GraphReader & | arcMap (const std::string &caption, Map &map, const Converter &converter=Converter())
| Arc map reading rule. More...
template<typename Value >
GraphReader & | attribute (const std::string &caption, Value &value)
| Attribute reading rule. More...
template<typename Value , typename Converter >
GraphReader & | attribute (const std::string &caption, Value &value, const Converter &converter=Converter())
| Attribute reading rule. More...
GraphReader & | node (const std::string &caption, Node &node)
| Node reading rule. More...
GraphReader & | edge (const std::string &caption, Edge &edge)
| Edge reading rule. More...
GraphReader & | arc (const std::string &caption, Arc &arc)
| Arc reading rule. More...
Select Section by Name
GraphReader & | nodes (const std::string &caption)
| Set `@nodes` section to be read. More...
GraphReader & | edges (const std::string &caption)
| Set `@edges` section to be read. More...
GraphReader & | attributes (const std::string &caption)
| Set `@attributes` section to be read. More...
Using Previously Constructed Node or Edge Set
template<typename Map >
GraphReader & | useNodes (const Map &map)
| Use previously constructed node set. More...
template<typename Map , typename Converter >
GraphReader & | useNodes (const Map &map, const Converter &converter=Converter())
| Use previously constructed node set. More...
template<typename Map >
GraphReader & | useEdges (const Map &map)
| Use previously constructed edge set. More...
template<typename Map , typename Converter >
GraphReader & | useEdges (const Map &map, const Converter &converter=Converter())
| Use previously constructed edge set. More...
GraphReader & | skipNodes ()
| Skip the reading of node section. More...
GraphReader & | skipEdges ()
| Skip the reading of edge section. More...
Execution of the Reader
void | run ()
| Start the batch processing. More...

## Related Functions
(Note that these are not member functions.)
template<typename TGR >
GraphReader< TGR > | graphReader (TGR &graph, std::istream &is)
| Return a GraphReader class. More...
template<typename TGR >
GraphReader< TGR > | graphReader (TGR &graph, const std::string &fn)
| Return a GraphReader class. More...
template<typename TGR >
GraphReader< TGR > | graphReader (TGR &graph, const char *fn)
| Return a GraphReader class. More...

## Constructor & Destructor Documentation

GraphReader | ( | GR & | graph,
|  | std::istream & | is = `std::cin`
| ) |  |
| inline

Construct an undirected graph reader, which reads from the given input stream.

GraphReader | ( | GR & | graph,
|  | const std::string & | fn
| ) |  |
| inline

Construct an undirected graph reader, which reads from the given file.

GraphReader | ( | GR & | graph,
|  | const char * | fn
| ) |  |
| inline

Construct an undirected graph reader, which reads from the given file.

## Member Function Documentation

GraphReader& nodeMap | ( | const std::string & | caption,
|  | Map & | map
| ) |  |
| inline

Add a node map reading rule to the reader.

GraphReader& nodeMap | ( | const std::string & | caption,
|  | Map & | map,
|  | const Converter & | converter = `Converter()`
| ) |  |
| inline

Add a node map reading rule with specialized converter to the reader.

GraphReader& edgeMap | ( | const std::string & | caption,
|  | Map & | map
| ) |  |
| inline

Add an edge map reading rule to the reader.

GraphReader& edgeMap | ( | const std::string & | caption,
|  | Map & | map,
|  | const Converter & | converter = `Converter()`
| ) |  |
| inline

Add an edge map reading rule with specialized converter to the reader.

GraphReader& arcMap | ( | const std::string & | caption,
|  | Map & | map
| ) |  |
| inline

Add an arc map reading rule to the reader.

GraphReader& arcMap | ( | const std::string & | caption,
|  | Map & | map,
|  | const Converter & | converter = `Converter()`
| ) |  |
| inline

Add an arc map reading rule with specialized converter to the reader.

GraphReader& attribute | ( | const std::string & | caption,
|  | Value & | value
| ) |  |
| inline

Add an attribute reading rule to the reader.

GraphReader& attribute | ( | const std::string & | caption,
|  | Value & | value,
|  | const Converter & | converter = `Converter()`
| ) |  |
| inline

Add an attribute reading rule with specialized converter to the reader.

GraphReader& node | ( | const std::string & | caption,
|  | Node & | node
| ) |  |
| inline

Add a node reading rule to reader.

GraphReader& edge | ( | const std::string & | caption,
|  | Edge & | edge
| ) |  |
| inline

Add an edge reading rule to reader.

GraphReader& arc | ( | const std::string & | caption,
|  | Arc & | arc
| ) |  |
| inline

Add an arc reading rule to reader.

GraphReader& nodes | ( | const std::string & | caption | ) |
| inline

Set `@nodes` section to be read.

GraphReader& edges | ( | const std::string & | caption | ) |
| inline

Set `@edges` section to be read.

GraphReader& attributes | ( | const std::string & | caption | ) |
| inline

Set `@attributes` section to be read.

GraphReader& useNodes | ( | const Map & | map | ) |
| inline

Use previously constructed node set, and specify the node label map.

GraphReader& useNodes | ( | const Map & | map,
|  | const Converter & | converter = `Converter()`
| ) |  |
| inline

Use previously constructed node set, and specify the node label map and a functor which converts the label map values to `std::string`.

GraphReader& useEdges | ( | const Map & | map | ) |
| inline

Use previously constructed edge set, and specify the edge label map.

GraphReader& useEdges | ( | const Map & | map,
|  | const Converter & | converter = `Converter()`
| ) |  |
| inline

Use previously constructed edge set, and specify the edge label map and a functor which converts the label map values to `std::string`.

GraphReader& skipNodes | ( |  | ) |
| inline

Omit the reading of the node section. This implies that each node map reading rule will be abandoned, and the nodes of the graph will not be constructed, which usually cause that the edge set could not be read due to lack of node name could not be read due to lack of node name resolving. Therefore `skipEdges()` function should also be used, or `useNodes()` should be used to specify the label of the nodes.

GraphReader& skipEdges | ( |  | ) |
| inline

Omit the reading of the edge section. This implies that each edge map reading rule will be abandoned, and the edges of the graph will not be constructed.

void run | ( |  | ) |
| inline

This function starts the batch processing

## Friends And Related Function Documentation

GraphReader< TGR > graphReader | ( | TGR & | graph,
|  | const std::string & | fn
| ) |  |
| related

This function just returns a GraphReader class.

See Also
  graphReader(TGR& graph, std::istream& is)

GraphReader< TGR > graphReader | ( | TGR & | graph,
|  | const char * | fn
| ) |  |
| related

This function just returns a GraphReader class.

See Also
  graphReader(TGR& graph, std::istream& is)